<?php
/**
 * Upload plugin, allows upload for users with correct 
 * permission fromin a wikipage to a defined namespace.
 * @license GPL 2 (http://www.gnu.org/licenses/gpl.html)
 * @author Christian Moll <christian@chrmoll.de>
 */

if(!defined('NL')) define('NL',"\n");
if(!defined('DOKU_INC')) define('DOKU_INC',dirname(__FILE__).'/../../');
if(!defined('DOKU_PLUGIN')) define('DOKU_PLUGIN',DOKU_INC.'lib/plugins/');
require_once(DOKU_PLUGIN.'syntax.php');
require_once(DOKU_INC.'inc/media.php');
require_once(DOKU_INC.'inc/auth.php');

// get namespace to display (either direct or from deletion order)
$NS = $_REQUEST['ns'];
$NS = cleanID($NS);

// check auth
$AUTH = auth_quickaclcheck("$NS:*");

// handle upload
if($_FILES['upload']['tmp_name']){
    $JUMPTO = media_upload($NS,$AUTH);
    if($JUMPTO) $NS = getNS($JUMPTO);
}

/**
 * Print the media upload form if permissions are correct
 * 
 * @author Christian Moll <christian@chrmoll.de>
 * @author Andreas Gohr <andi@splitbrain.org>
 */
function upload_plugin_uploadform($ns, $auth, $overwrite){
    global $lang;
    global $ID;

    if($auth < AUTH_UPLOAD) return;
    
    // Modification of the default dw HTML upload form
    $form = new Doku_Form('upload_plugin', 'doku.php?id='.$ID, false, 'multipart/form-data');
    $form->addElement(formSecurityToken());
    $form->addHidden('ns', hsc($ns));
    $form->addElement(form_makeOpenTag('p'));
    $form->addElement(form_makeFileField('upload', $lang['txt_upload'].':', 'upload__file'));
    $form->addElement(form_makeButton('submit', '', $lang['btn_upload']));
    $form->addElement(form_makeCloseTag('p'));
    if($auth >= AUTH_DELETE){
       if($overwrite=="OVERWRITE"){
          $form->addElement(form_makeOpenTag('p'));
          $form->addElement(form_makeCheckboxField('ow', 1, $lang['txt_overwrt'], 'dw__ow', 'check'));
	  $form->addElement(form_makeCloseTag('p'));
       }
    }
    ob_start();
    print '<div class="upload_plugin"><p>'.NL;
    $form->printForm();
    print '</p></div>'.NL;
    $out .= ob_get_contents();
    ob_end_clean();
    return $out;
    
}


class syntax_plugin_upload extends DokuWiki_Syntax_Plugin {
 
    function getInfo(){
        return array(
            'author' => 'Christian Moll',
            'email'  => 'christian@chrmoll.de',
            'date'   => '2009-08-19',
            'name'   => 'upload plugin',
            'desc'   => 'upload plugin can add a link to the media manager in your wikipage.
            			Basic syntax: {{upload>namespace|alternativ label}}
				Use @page@ as namespage to use ID of the actual page as namespace.',
            'url'    => 'http://wiki.splitbrain.org/plugin:upload',
        );
    }
 
    function getType(){
        return 'substition';
    }
    
    function getSort(){
        return 32;
    }
 
    function connectTo($mode) {
      $this->Lexer->addSpecialPattern('\{\{upload>.+?\}\}',$mode,'plugin_upload');
    }
	
    function handle($match, $state, $pos, &$handler){
   
		$match = substr($match,9, -2);
		$matches=explode('|', $match, 2);
		
		return array('uploadns'=>hsc($matches[0]),'para'=>hsc($matches[1]));
    }
 
    function render($mode, &$renderer, $data){
	if($mode == 'xhtml'){
		
		global $ID;
		global $INFO;
		global $REV;
		global $ACT;
		global $conf;
		global $lang;
		global $auth;
		
		if(!empty($data['uploadns'])) $uploadns=$data['uploadns'];
		else $uploadns='';
		if(!empty($data['para'])) $para=$data['para'];
		else $para=$ID;
		
		if($uploadns=='@page@') $uploadns=$ID;
		
		//check auth
		$auth = auth_quickaclcheck("$uploadns:*");
		
		if($auth >= AUTH_UPLOAD){
			$renderer->doc.=upload_plugin_uploadform($uploadns, $auth, $para);
			return true;
		} else {
			return true;
		}
        }
        return false;
    }

}
 
//Setup VIM: ex: et ts=4 enc=utf-8 :